 


   variable LogFlag 0

    proc InsertLog {s} {puts "$s"}


    variable PROJECT $::DataAcquisition::PROJECT
    variable OptionSet "Global"


   proc LoadOptions {} {
      variable PROJECT
      variable OptionSet

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

      catch {unset ::Options}

      foreach item [split [DBGetValue Index] &&] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         set vl [DBGetValue $item]
         if {$vl != "Error!"} {set ::Options($item) $vl}
      }

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }

   proc SaveOptions {} {
      variable PROJECT
      variable OptionSet

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

      set OptionList ""
      foreach item [array names ::Options] {
         if {$item == "Index"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue "$item" [first [set ::Options($item)]]
      }
      DBSetValue Index $OptionList

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }


   proc SpecSave {} {
      global env
      variable PROJECT
      global SpectrumServerHost

      InsertLog "Saving histograms"

      set f1 [file join $env(MIDASBASE) SpecData $PROJECT]
      set z [catch {file mkdir $f1} m]
      set f2 [file join $env(MIDASBASE) SpecData $PROJECT [date +%Y%h%d-%H.%M.%S]]
      set z [catch {file mkdir $f2} m]

      set SpecNames [SpectrumNames]
      set NumSpec 0
      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a valid histogram !!

         set SpecName [second $item]

         set from [set SpectrumServerHost]:8015/SpectrumService/$SpecName
         set to [file join $f2 $SpecName]

         set execute "exec copy-soap-spectrum  $from $to"
         set rc [catch {eval $execute} m]
      
         if {$rc == 0} {
            InsertLog "$m"
         } else {
            InsertLog "CopySpectrum returns an error: $m"
         }

         incr NumSpec
      }

      InsertLog "$NumSpec Histograms saved to $f2"
#      Elog INFORMATION "Histograms saved to $f2"

     return "$NumSpec Histograms saved to $f2"

   }




