

#    support for Web Service access  -  provides application specific support

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

puts "loading Html/AIDA/RunControl/implementation.tcl for namespace [namespace current]"

#   include other program files

global env

    set f [file join $env(MIDASBASE) TclHttpd Html AIDA RunControl common.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "RunControl returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html AIDA RunControl sys.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "RunControl returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html AIDA RunControl stats.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "RunControl returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html AIDA RunControl stats.defn.tcl]
    if {[file exists $f]} {
#    note that reading this defines the elements of the ITEM array
        set z [catch {source $f} m]
puts "loading stats.defn.tcl returns $z & $m"
    }


proc Appdo_SetOption {args} {
    variable SYS_DataAcquisitionCode
    variable SYS_PrevDataAcquisitionCode
    variable SYS_DataAcquisitionArgs
    variable RunControlDelay1

# puts "do_SetOption:  Acquisition state = $SYS_DataAcquisitionCode args = $args"

    set SYS_DataAcquisitionArgs $args

    after $RunControlDelay1 {
        set z [catch {::namespace inscope ::urn:DataAcquisitionControlServer do_SetOptionC} m]
        if {$z != 0} {puts "do_SetOption gets $m"}
    }

   set SYS_PrevDataAcquisitionCode $SYS_DataAcquisitionCode
   set SYS_DataAcquisitionCode 9

# puts "SetOption: DataAcquisitionCode = $SYS_DataAcquisitionCode"
}

proc do_SetOptionC {} {
   global env
    variable SYS_DataAcquisitionCode
    variable SYS_PrevDataAcquisitionCode
    variable SYS_DataAcquisitionArgs

   set args $SYS_DataAcquisitionArgs

   if {[llength $args] == 1} {set args [first $args]}

   set state [lindex $args 0]
   set opt [lindex $args 1]

   set cmd [first [split $opt =]]
   set vl [second [split $opt =]]

   switch $cmd {
        ClearStats  {
          set z [catch {do_clearstats} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        ParameterSave  {
          set z [catch {ParameterSave} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        ParameterRestore  {
          set z [catch {ParameterRestore} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        OptionSave  {
          set z [catch {update_Options} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        OptionRestore  {
          set z [catch {load_Options} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        HistogramSave  {
          set z [catch {SpecSave} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }	
        SoftwareReload   {
          set f [file join $env(MIDASBASE) TclHttpd tcl AIDARunControl.tcl]
          set z [catch {source $f} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
   
            puts "Project RunControl Implementation reloaded"
        }
        ResetElectronics  {
          set z [catch {Reset_Electronics} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        StopElectronics  {
          set z [catch {Stop_Electronics} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        GoElectronics  {
          set z [catch {Go_Electronics} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        SetupElectronics  {
          set z [catch {Setup_Electronics} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        LoadExec  -
        TerminateExec  {
          set z [catch {$cmd} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        HistEnable {WriteNetVar NetVar.DACQ.Chistenable $vl}
        XferEnable {WriteNetVar NetVar.DACQ.Ctxenable $vl}
        default    {puts "SetOption: Unknown Acquisition Option state=$state; opt=\"$opt\"; cmd=$cmd; vl=$vl"}
    }

   set SYS_DataAcquisitionCode $SYS_PrevDataAcquisitionCode
}






